// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.25.0-devel
// 	protoc        v3.13.0
// source: carga.proto

package carga

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

type Data struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	Body           string `protobuf:"bytes,1,opt,name=Body,proto3" json:"Body,omitempty"`
	ChunkData      []byte `protobuf:"bytes,2,opt,name=ChunkData,proto3" json:"ChunkData,omitempty"`
	Tipo           int32  `protobuf:"varint,3,opt,name=Tipo,proto3" json:"Tipo,omitempty"` //Tipo de algoritmo (centralizado o distribuido)
	NombreLibro    string `protobuf:"bytes,4,opt,name=NombreLibro,proto3" json:"NombreLibro,omitempty"`
	CantidadChunks uint64 `protobuf:"varint,5,opt,name=CantidadChunks,proto3" json:"CantidadChunks,omitempty"`
}

func (x *Data) Reset() {
	*x = Data{}
	if protoimpl.UnsafeEnabled {
		mi := &file_carga_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Data) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Data) ProtoMessage() {}

func (x *Data) ProtoReflect() protoreflect.Message {
	mi := &file_carga_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Data.ProtoReflect.Descriptor instead.
func (*Data) Descriptor() ([]byte, []int) {
	return file_carga_proto_rawDescGZIP(), []int{0}
}

func (x *Data) GetBody() string {
	if x != nil {
		return x.Body
	}
	return ""
}

func (x *Data) GetChunkData() []byte {
	if x != nil {
		return x.ChunkData
	}
	return nil
}

func (x *Data) GetTipo() int32 {
	if x != nil {
		return x.Tipo
	}
	return 0
}

func (x *Data) GetNombreLibro() string {
	if x != nil {
		return x.NombreLibro
	}
	return ""
}

func (x *Data) GetCantidadChunks() uint64 {
	if x != nil {
		return x.CantidadChunks
	}
	return 0
}

type Descarga struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	Pieza  string `protobuf:"bytes,1,opt,name=Pieza,proto3" json:"Pieza,omitempty"`
	Puerto string `protobuf:"bytes,2,opt,name=Puerto,proto3" json:"Puerto,omitempty"`
}

func (x *Descarga) Reset() {
	*x = Descarga{}
	if protoimpl.UnsafeEnabled {
		mi := &file_carga_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Descarga) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Descarga) ProtoMessage() {}

func (x *Descarga) ProtoReflect() protoreflect.Message {
	mi := &file_carga_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Descarga.ProtoReflect.Descriptor instead.
func (*Descarga) Descriptor() ([]byte, []int) {
	return file_carga_proto_rawDescGZIP(), []int{1}
}

func (x *Descarga) GetPieza() string {
	if x != nil {
		return x.Pieza
	}
	return ""
}

func (x *Descarga) GetPuerto() string {
	if x != nil {
		return x.Puerto
	}
	return ""
}

type Chunk struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	NombreParte string `protobuf:"bytes,2,opt,name=NombreParte,proto3" json:"NombreParte,omitempty"`
	Chu         []byte `protobuf:"bytes,1,opt,name=Chu,proto3" json:"Chu,omitempty"`
}

func (x *Chunk) Reset() {
	*x = Chunk{}
	if protoimpl.UnsafeEnabled {
		mi := &file_carga_proto_msgTypes[2]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *Chunk) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Chunk) ProtoMessage() {}

func (x *Chunk) ProtoReflect() protoreflect.Message {
	mi := &file_carga_proto_msgTypes[2]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Chunk.ProtoReflect.Descriptor instead.
func (*Chunk) Descriptor() ([]byte, []int) {
	return file_carga_proto_rawDescGZIP(), []int{2}
}

func (x *Chunk) GetNombreParte() string {
	if x != nil {
		return x.NombreParte
	}
	return ""
}

func (x *Chunk) GetChu() []byte {
	if x != nil {
		return x.Chu
	}
	return nil
}

var File_carga_proto protoreflect.FileDescriptor

var file_carga_proto_rawDesc = []byte{
	0x0a, 0x0b, 0x63, 0x61, 0x72, 0x67, 0x61, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x05, 0x63,
	0x61, 0x72, 0x67, 0x61, 0x22, 0x96, 0x01, 0x0a, 0x04, 0x44, 0x61, 0x74, 0x61, 0x12, 0x12, 0x0a,
	0x04, 0x42, 0x6f, 0x64, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x04, 0x42, 0x6f, 0x64,
	0x79, 0x12, 0x1c, 0x0a, 0x09, 0x43, 0x68, 0x75, 0x6e, 0x6b, 0x44, 0x61, 0x74, 0x61, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x0c, 0x52, 0x09, 0x43, 0x68, 0x75, 0x6e, 0x6b, 0x44, 0x61, 0x74, 0x61, 0x12,
	0x12, 0x0a, 0x04, 0x54, 0x69, 0x70, 0x6f, 0x18, 0x03, 0x20, 0x01, 0x28, 0x05, 0x52, 0x04, 0x54,
	0x69, 0x70, 0x6f, 0x12, 0x20, 0x0a, 0x0b, 0x4e, 0x6f, 0x6d, 0x62, 0x72, 0x65, 0x4c, 0x69, 0x62,
	0x72, 0x6f, 0x18, 0x04, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x4e, 0x6f, 0x6d, 0x62, 0x72, 0x65,
	0x4c, 0x69, 0x62, 0x72, 0x6f, 0x12, 0x26, 0x0a, 0x0e, 0x43, 0x61, 0x6e, 0x74, 0x69, 0x64, 0x61,
	0x64, 0x43, 0x68, 0x75, 0x6e, 0x6b, 0x73, 0x18, 0x05, 0x20, 0x01, 0x28, 0x04, 0x52, 0x0e, 0x43,
	0x61, 0x6e, 0x74, 0x69, 0x64, 0x61, 0x64, 0x43, 0x68, 0x75, 0x6e, 0x6b, 0x73, 0x22, 0x38, 0x0a,
	0x08, 0x44, 0x65, 0x73, 0x63, 0x61, 0x72, 0x67, 0x61, 0x12, 0x14, 0x0a, 0x05, 0x50, 0x69, 0x65,
	0x7a, 0x61, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05, 0x50, 0x69, 0x65, 0x7a, 0x61, 0x12,
	0x16, 0x0a, 0x06, 0x50, 0x75, 0x65, 0x72, 0x74, 0x6f, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x06, 0x50, 0x75, 0x65, 0x72, 0x74, 0x6f, 0x22, 0x3b, 0x0a, 0x05, 0x43, 0x68, 0x75, 0x6e, 0x6b,
	0x12, 0x20, 0x0a, 0x0b, 0x4e, 0x6f, 0x6d, 0x62, 0x72, 0x65, 0x50, 0x61, 0x72, 0x74, 0x65, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x4e, 0x6f, 0x6d, 0x62, 0x72, 0x65, 0x50, 0x61, 0x72,
	0x74, 0x65, 0x12, 0x10, 0x0a, 0x03, 0x43, 0x68, 0x75, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0c, 0x52,
	0x03, 0x43, 0x68, 0x75, 0x32, 0x6b, 0x0a, 0x0c, 0x43, 0x61, 0x72, 0x67, 0x61, 0x53, 0x65, 0x72,
	0x76, 0x69, 0x63, 0x65, 0x12, 0x2a, 0x0a, 0x0a, 0x55, 0x70, 0x6c, 0x6f, 0x61, 0x64, 0x44, 0x61,
	0x74, 0x61, 0x12, 0x0b, 0x2e, 0x63, 0x61, 0x72, 0x67, 0x61, 0x2e, 0x44, 0x61, 0x74, 0x61, 0x1a,
	0x0b, 0x2e, 0x63, 0x61, 0x72, 0x67, 0x61, 0x2e, 0x44, 0x61, 0x74, 0x61, 0x22, 0x00, 0x28, 0x01,
	0x12, 0x2f, 0x0a, 0x0c, 0x44, 0x6f, 0x77, 0x6e, 0x6c, 0x6f, 0x61, 0x64, 0x44, 0x61, 0x74, 0x61,
	0x12, 0x0f, 0x2e, 0x63, 0x61, 0x72, 0x67, 0x61, 0x2e, 0x44, 0x65, 0x73, 0x63, 0x61, 0x72, 0x67,
	0x61, 0x1a, 0x0c, 0x2e, 0x63, 0x61, 0x72, 0x67, 0x61, 0x2e, 0x43, 0x68, 0x75, 0x6e, 0x6b, 0x22,
	0x00, 0x42, 0x09, 0x5a, 0x07, 0x2e, 0x3b, 0x63, 0x61, 0x72, 0x67, 0x61, 0x62, 0x06, 0x70, 0x72,
	0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_carga_proto_rawDescOnce sync.Once
	file_carga_proto_rawDescData = file_carga_proto_rawDesc
)

func file_carga_proto_rawDescGZIP() []byte {
	file_carga_proto_rawDescOnce.Do(func() {
		file_carga_proto_rawDescData = protoimpl.X.CompressGZIP(file_carga_proto_rawDescData)
	})
	return file_carga_proto_rawDescData
}

var file_carga_proto_msgTypes = make([]protoimpl.MessageInfo, 3)
var file_carga_proto_goTypes = []interface{}{
	(*Data)(nil),     // 0: carga.Data
	(*Descarga)(nil), // 1: carga.Descarga
	(*Chunk)(nil),    // 2: carga.Chunk
}
var file_carga_proto_depIdxs = []int32{
	0, // 0: carga.CargaService.UploadData:input_type -> carga.Data
	1, // 1: carga.CargaService.DownloadData:input_type -> carga.Descarga
	0, // 2: carga.CargaService.UploadData:output_type -> carga.Data
	2, // 3: carga.CargaService.DownloadData:output_type -> carga.Chunk
	2, // [2:4] is the sub-list for method output_type
	0, // [0:2] is the sub-list for method input_type
	0, // [0:0] is the sub-list for extension type_name
	0, // [0:0] is the sub-list for extension extendee
	0, // [0:0] is the sub-list for field type_name
}

func init() { file_carga_proto_init() }
func file_carga_proto_init() {
	if File_carga_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_carga_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Data); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_carga_proto_msgTypes[1].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Descarga); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_carga_proto_msgTypes[2].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*Chunk); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_carga_proto_rawDesc,
			NumEnums:      0,
			NumMessages:   3,
			NumExtensions: 0,
			NumServices:   1,
		},
		GoTypes:           file_carga_proto_goTypes,
		DependencyIndexes: file_carga_proto_depIdxs,
		MessageInfos:      file_carga_proto_msgTypes,
	}.Build()
	File_carga_proto = out.File
	file_carga_proto_rawDesc = nil
	file_carga_proto_goTypes = nil
	file_carga_proto_depIdxs = nil
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConnInterface

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion6

// CargaServiceClient is the client API for CargaService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type CargaServiceClient interface {
	UploadData(ctx context.Context, opts ...grpc.CallOption) (CargaService_UploadDataClient, error)
	DownloadData(ctx context.Context, in *Descarga, opts ...grpc.CallOption) (*Chunk, error)
}

type cargaServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewCargaServiceClient(cc grpc.ClientConnInterface) CargaServiceClient {
	return &cargaServiceClient{cc}
}

func (c *cargaServiceClient) UploadData(ctx context.Context, opts ...grpc.CallOption) (CargaService_UploadDataClient, error) {
	stream, err := c.cc.NewStream(ctx, &_CargaService_serviceDesc.Streams[0], "/carga.CargaService/UploadData", opts...)
	if err != nil {
		return nil, err
	}
	x := &cargaServiceUploadDataClient{stream}
	return x, nil
}

type CargaService_UploadDataClient interface {
	Send(*Data) error
	CloseAndRecv() (*Data, error)
	grpc.ClientStream
}

type cargaServiceUploadDataClient struct {
	grpc.ClientStream
}

func (x *cargaServiceUploadDataClient) Send(m *Data) error {
	return x.ClientStream.SendMsg(m)
}

func (x *cargaServiceUploadDataClient) CloseAndRecv() (*Data, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(Data)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *cargaServiceClient) DownloadData(ctx context.Context, in *Descarga, opts ...grpc.CallOption) (*Chunk, error) {
	out := new(Chunk)
	err := c.cc.Invoke(ctx, "/carga.CargaService/DownloadData", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CargaServiceServer is the server API for CargaService service.
type CargaServiceServer interface {
	UploadData(CargaService_UploadDataServer) error
	DownloadData(context.Context, *Descarga) (*Chunk, error)
}

// UnimplementedCargaServiceServer can be embedded to have forward compatible implementations.
type UnimplementedCargaServiceServer struct {
}

func (*UnimplementedCargaServiceServer) UploadData(CargaService_UploadDataServer) error {
	return status.Errorf(codes.Unimplemented, "method UploadData not implemented")
}
func (*UnimplementedCargaServiceServer) DownloadData(context.Context, *Descarga) (*Chunk, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DownloadData not implemented")
}

func RegisterCargaServiceServer(s *grpc.Server, srv CargaServiceServer) {
	s.RegisterService(&_CargaService_serviceDesc, srv)
}

func _CargaService_UploadData_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(CargaServiceServer).UploadData(&cargaServiceUploadDataServer{stream})
}

type CargaService_UploadDataServer interface {
	SendAndClose(*Data) error
	Recv() (*Data, error)
	grpc.ServerStream
}

type cargaServiceUploadDataServer struct {
	grpc.ServerStream
}

func (x *cargaServiceUploadDataServer) SendAndClose(m *Data) error {
	return x.ServerStream.SendMsg(m)
}

func (x *cargaServiceUploadDataServer) Recv() (*Data, error) {
	m := new(Data)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _CargaService_DownloadData_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Descarga)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CargaServiceServer).DownloadData(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/carga.CargaService/DownloadData",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CargaServiceServer).DownloadData(ctx, req.(*Descarga))
	}
	return interceptor(ctx, in, info, handler)
}

var _CargaService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "carga.CargaService",
	HandlerType: (*CargaServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "DownloadData",
			Handler:    _CargaService_DownloadData_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "UploadData",
			Handler:       _CargaService_UploadData_Handler,
			ClientStreams: true,
		},
	},
	Metadata: "carga.proto",
}
